'PrpDelObject.vbs
'Delete an object from an Uru Prp file
'Chacal 2010

'This script will permanently delete a visible and/or physical object from a prp
'initialization of globals
Dim currentDirectory, logFilename, xmlConfig, xmlDoc, libPlasmaPath, gamePath, plSceneObjectName, plDrawInterfaceName, plSimulationInterfaceName, objectDrawables, plGenericPhysicalName
Include "Lib.vbs"
logFilename = "PrpDelObject.log"

'Get prp file and object from command line, or let user enter them
If Wscript.Arguments.Count = 0 Then
   'Get prp file name
   prpFileName = InputBox("Name of prp file: ") 
   'Get object name
   plSceneObjectName = InputBox("Name of object you want to delete from: " & prpFileName) 
Else
   If Wscript.Arguments.Count = 2 Then
      prpFileName = Wscript.Arguments(0)
      plSceneObjectName = Wscript.Arguments(1)
   Else
      Wscript.Echo "    PrpDelObject.vbs - Delete an object from a Prp file - Chacal 2010" & Vbcrlf & "    Usage: PrpDelObj [path\name of prp file][Name of object]"
      Wscript.Quit
   End If
End If
WriteLog "PrpDelObject: Attempting to delete object " & plSceneObjectName &" from " & prpFileName

' Get user config from config.xml file
If Not GetUserConfig ("Config.xml") Then
   Wscript.Quit
End If

'Copy prp file from game into current directory
If Not CopyFileFromGame ("dat",prpFileName) Then
   Wscript.Quit
End If

'Backup prp file
If Not BackupFile (prpFileName) Then
   Wscript.Quit
End If

'Get names of object's interfaces
If Not GetObjectInterfaces (plDrawInterfaceName, plSimulationInterfaceName) Then
   Wscript.Quit
End If
	
If plDrawInterfaceName <> "" Then
   'Get object's drawables
   If Not GetObjectDrawables (plDrawInterfaceName,objectDrawables) Then
      Wscript.Quit
   End If
   'Delete all the object's drawables
   If Not DeleteObjectDrawables (objectDrawables) Then
      Wscript.Quit
   End If
End If

If plSimulationInterfaceName <> "" Then
'Get name of object's plGenericPhysical
   If Not GetObjectPhysical (plSimulationInterfaceName,plGenericPhysicalName) Then
      Wscript.Quit
   End If
   'Delete object's plGenericPhysical
   If Not PrpDelObj (prpFileName, "plGenericPhysical", plGenericPhysicalName) Then
   'Don't care about any error here
   End If
Else
   WriteLog "PrpDelObject: Object had no physical."
End If

'Copy prp file to game from current directory
If Not CopyFileToGame ("dat",prpFileName) Then
   Wscript.Quit
End If

'Delete prp file from current directory
DeleteFile (prpFileName)

'All done.
WriteLog "PrpDelObject: Object " & plSceneObjectName &" was deleted from " & prpFileName
Wscript.Echo "Object " & plSceneObjectName &" was deleted from " & prpFileName

' VBScript "Include" routine
Sub Include(sInstFile)
	'On Error Resume Next
	Dim oFSO, f, s
	Set oFSO = CreateObject("Scripting.FileSystemObject")
	If oFSO.FileExists(sInstFile) Then
		Set f = oFSO.OpenTextFile(sInstFile)
		s = f.ReadAll
		f.Close
		ExecuteGlobal s
	End If
	Set oFSO = Nothing
	Set f = Nothing
End Sub
